<template>
  <div
    class="ui-container relative z-0 mx-auto grid w-full max-w-max grid-cols-[100%] gap-4 md:grid-cols-[max-content_minmax(0,1fr)] md:gap-y-0 md:duration-300 md:ease-in-out md:[transition-property:gap] lg:gap-x-6 xl:gap-x-12"
    :class="{
      'px-3 md:px-4 lg:px-6': hasPagePadding,
      'gap-0': !hasSidebar,
    }"
  >
    <div
      class="z-0 w-full md:col-[1/1] md:w-52 md:duration-300 md:ease-in-out md:[transition-property:transform,width,opacity] md:[will-change:transform,width,opacity] lg:w-72 xl:w-96"
      :class="{
        'block h-0 !w-0 scale-90 overflow-hidden opacity-0 md:h-auto':
          !hasSidebar,
      }"
      :aria-hidden="!hasSidebar"
    >
      <component :is="sidebarTag" class="w-full md:w-52 lg:w-72 xl:w-96">
        <slot name="sidebar" />
      </component>
    </div>
    <component
      :is="tag"
      class="z-10 w-full max-w-full md:col-[2/2] md:w-[calc(62ch+theme(padding.8))] lg:w-[calc(62ch+theme(padding.12))] lg:text-[1.125rem] xl:w-[calc(62ch+theme(padding.16))] xl:text-[1.25rem]"
    >
      <slot />
    </component>
  </div>
</template>

<script lang="ts" setup>
defineOptions({
  name: 'UiContainer',
})

defineProps({
  hasPagePadding: {
    type: Boolean,
    default: false,
  },
  hasSidebar: {
    type: Boolean,
    default: false,
  },
  sidebarTag: {
    type: String,
    default: 'div',
  },
  tag: {
    type: String,
    default: 'div',
  },
})
</script>
